chiark / gitweb /
b7763056fa2cca759e115a1421b93c0b0bc534b5
[dgit.git] / tests / lib
1 #
2
3 exec 2>&1
4 set -x
5 set -o pipefail
6
7 . tests/lib-core
8 . tests/lib-restricts
9
10 t-report-failure () {
11         set +x
12         rc=$1
13         cat <<END >&2
14 TEST FAILED
15 funcs: ${FUNCNAME[*]}
16 lines: ${BASH_LINENO[*]}
17 files: ${BASH_SOURCE[*]}
18 END
19         exit 16
20 }
21
22 trap 'test $? = 0 || t-report-failure' EXIT
23
24 t-filter-out-git-hyphen-dir
25
26 t-set-intree
27
28 : ${DGIT_TEST_DEBUG=-D}
29 export DGIT_TEST_DEBUG
30
31 export GIT_COMMITTER_DATE='1440253867 +0100'
32 export GIT_AUTHOR_DATE='1440253867 +0100'
33
34 root=`pwd`
35 troot=$root/tests
36 testname="${DGIT_TEST_TESTNAME-${0##*/}}"
37
38 tmp=$ADTTMP
39 if [ x"$tmp" = x ]; then
40         mkdir -p tests/tmp
41         tmpbase=$troot/tmp
42         tmp=tests/tmp/$testname
43         rm -rf $tmp
44         mkdir $tmp
45 elif [ "x$DGIT_TEST_TMPBASE" != x ]; then
46         tmpbase="$DGIT_TEST_TMPBASE"
47 fi
48 cd $tmp
49
50 tmp=`pwd`
51
52 t-set-using-tmp
53
54 env -0 >$tmp/.save-env
55
56 ln -f $troot/ssh ssh
57
58 export DEBCHANGE_VENDOR=dpkg
59
60 mkdir -p $tmp/incoming
61 cat <<END >$tmp/dput.cf
62 [test-dummy]
63 method                  = local
64 incoming                = $tmp/incoming
65 run_dinstall            = 0
66 END
67
68 : ${t_archive_method:=aq}
69 : ${tagpfx:=archive/test-dummy}
70 : ${suitespecs:=sid:unstable}
71
72 t-git-next-date () {
73         GIT_COMMITTER_DATE="$(( ${GIT_COMMITTER_DATE%% *} + 1 )) ${GIT_COMMITTER_DATE#* }"
74         GIT_AUTHOR_DATE="$GIT_COMMITTER_DATE"
75 }
76
77 t-expect-fail () {
78         local mpat="$1"; shift
79
80         set +o pipefail
81         LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
82         local ps="${PIPESTATUS[*]}"
83         set -o pipefail
84
85         case $ps in
86         "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
87         *" 0")  ;;
88         *)      fail "tee failed"  ;;
89         esac
90
91         t-grep-mpat "$mpat" $tmp/t.output
92 }
93
94 t-grep-mpat () {
95         local mpat="$1"
96         local file="$2"
97
98         local grepper=fgrep
99         case "$mpat" in
100         [A-Z]:*)
101                 case "$mpat" in
102                 E:*)    grepper=egrep   ;;
103                 F:*)    grepper=fgrep   ;;
104                 *)      fail "bad mpat prefix in $mpat";;
105                 esac
106                 mpat=${mpat#[A-Z]:}
107                 ;;
108         esac
109
110         $grepper -e "$mpat" "$file" ||
111                 fail "message not found"
112 }
113
114 t-expect-push-fail () {
115         local mpat="$1"; shift
116
117         local triedpush=`git rev-parse HEAD`
118
119         t-reporefs pre-push
120         t-expect-fail "$mpat"  "$@"
121         t-reporefs post-push
122         diff $tmp/show-refs.{pre,post}-push
123
124         t-git-objects-not-present '' $triedpush
125
126         eval "$t_expect_push_fail_hook"
127 }
128
129 t-git-objects-not-present () {
130         # t-git-objects-not-present GITDIR|'' OBJID [...]
131         # specifying '' means the repo for package $p
132         local gitdir="${1-$dgitrepo}"
133         local obj
134         if ! [ -e "$gitdir" ]; then return; fi
135         for obj in "$@"; do
136                 GIT_DIR=$gitdir \
137                 t-expect-fail 'unable to find' \
138                 git cat-file -t $obj
139         done
140 }
141
142 t-reporefs () {
143         local whichoutput=$1; shift
144         local whichrepo=${1-$dgitrepo}
145         local outputfile="$tmp/show-refs.$whichoutput"
146         (set -e
147          exec >"$outputfile"
148          if test -d $whichrepo; then
149                 cd $whichrepo
150                 git show-ref |sort
151         fi)
152 }
153
154 t-untar () {
155         local tarfile=$1.tar
156         local edittree=$1.edit
157         if test -d "$edittree"; then
158                 cp -a "$edittree"/* .
159         else
160                 tar xf "$tarfile"
161         fi
162 }
163
164 t-worktree () {
165         rm -rf $p
166         t-untar $troot/worktrees/${p}_$1
167 }
168
169 t-select-package () {
170         p=$1
171         dgitrepo=$tmp/git/$p.git
172 }
173
174 t-git () {
175         t-select-package $1
176         v=$2
177         mkdir -p $tmp/git
178         local gs=$troot/git-srcs/${p}_$v.git
179         (set -e; cd $tmp/git; t-untar $gs)
180 }
181
182 t-git-none () {
183         mkdir -p $tmp/git
184         (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
185 }
186
187 t-git-merge-base () {
188         git merge-base $1 $2 || test $? = 1
189 }
190
191 t-has-ancestor () {
192         # t-has-ancestor ANCESTOR
193         # (CHILD is implicit, HEAD)
194         local now=`git rev-parse HEAD`
195         local ancestor=`git rev-parse $1^{}`
196         local mbase=`t-git-merge-base $ancestor $now`
197         if [ x$mbase != x$ancestor ]; then
198                 fail "not ff $ancestor..$now, $mbase != $ancestor"
199         fi
200 }
201
202 t-has-parent-or-is () {
203         # t-has-parent-or-is CHILD PARENT
204         local child=$1
205         local parent=$2
206         local parents=$(git show --pretty=format:' %P %H ' "$child")
207         parent=$(git rev-parse "$parent~0")
208         case "$parents" in
209         *" $parent "*)  ;;
210         *)      fail "child $child lacks parent $parent" ;;
211         esac
212 }
213
214 t-prep-newpackage () {
215         t-select-package $1
216         v=$2
217         t-archive-none $p
218         t-git-none
219         t-worktree $v
220         cd $p
221         if ! git show-ref --verify --quiet refs/heads/master; then
222                 git branch -m dgit/sid master
223                 git remote rm dgit
224         fi
225         cd ..
226 }
227
228 t-archive-none () {
229         t-select-package $1
230         t-archive-none-$t_archive_method
231 }
232 t-archive-none-aq () {
233         mkdir -p $tmp/aq/dsc_in_suite $tmp/mirror/pool/main
234
235         : >$tmp/aq/suites
236         local jsondelim="["
237
238         local suitespec
239         for suitespec in $suitespecs; do
240                 local suite=${suitespec%%:*}
241                 local sname=${suitespec#*:}
242
243                 >$tmp/aq/package.$suite.$p
244                 t-aq-archive-updated $suite $p
245
246                 >$tmp/aq/package.new.$p
247                 t-aq-archive-updated new $p
248
249                 ln -sf $suite $tmp/aq/dsc_in_suite/$sname
250
251                 cat <<END >>$tmp/aq/suites
252 $jsondelim
253    {
254       "archive" : "ftp-master",
255       "codename" : "$suite",
256       "components" : [
257          "main",
258          "contrib",
259          "non-free"
260       ],
261       "name" : "$sname",
262       "dakname" : "$sname"
263 END
264
265                 jsondelim="   },"
266
267         done
268         cat <<END >>$tmp/aq/suites
269     }
270 ]
271 END
272 }
273
274 t-aq-archive-updated () {
275         local suite=$1
276         local p=$2
277         local suitedir=$tmp/aq/dsc_in_suite/$suite
278         mkdir -p $suitedir
279         perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
280                 use JSON;
281                 use strict;
282                 our @v;
283                 m{^(\S+) (\w+) ([^ \t/]+)/(\S+)} or die;
284                 push @v, {
285                         "version" => "$1",
286                         "sha256sum" => "$2",
287                         "component" => "$3",
288                         "filename" => "$4",
289                 };
290                 END {
291                         my $json = JSON->new->canonical();
292                         print $json->encode(\@v) or die $!;
293                 }
294         '
295 }
296
297 t-archive-process-incoming () {
298         local suite=$1
299         mv $tmp/incoming/${p}_* $tmp/mirror/pool/main/
300         t-archive-query "$suite"
301 }
302
303 t-archive-query () {
304         local suite=${1-sid}
305         local dscf=main/${p}_${v}.dsc
306         t-archive-query-$t_archive_method "$suite" "$p" "$v" "$dscf"
307 }
308 t-archive-query-aq () {
309         local suite=$1
310         local p=$2
311         local v=$3
312         local dscf=$4
313         local sha=`sha256sum <$tmp/mirror/pool/$dscf`
314         echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
315         t-aq-archive-updated $suite $p
316 }
317
318 t-archive () {
319         t-archive-none $1
320         v=$2
321         local dscf=${p}_$2.dsc
322         rm -f $tmp/mirror/pool/main/${p}_*
323         ln $troot/pkg-srcs/${p}_${2%-*}* $tmp/mirror/pool/main/
324         t-archive-query $suite
325         rm -rf $tmp/extract
326         mkdir $tmp/extract
327         (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
328 }
329
330 t-git-dir-time-passes () {
331         touch -d 'last year' $dgitrepo
332 }
333
334 t-git-dir-check () {
335         local gitdir=$dgitrepo
336         case "$1" in
337         enoent)
338                 if test -e "$gitdir"; then fail "$gitdir exists"; fi
339                 return
340                 ;;
341         public) wantstat='7[75]5' ;;
342         secret) wantstat='7[70]0' ;;
343         *)      fail "$1 t-git-dir-check ?" ;;
344         esac
345         gotstat=`stat -c%a $gitdir`
346         case "$gotstat" in
347         *$wantstat) return ;;
348         *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
349         esac
350 }
351
352 t-ok () {
353         echo ok.
354 }
355
356 t-rm-dput-dropping () {
357         rm -f $tmp/${p}_${v}_*.upload
358 }
359
360 t-dgit () {
361         local dgit=${DGIT_TEST-dgit}
362         pwd
363         : '
364 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
365         $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
366                 -dtest-dummy $DGIT_TEST_OPTS $DGIT_TEST_DEBUG \
367                 -k39B13D8A $t_dgit_xopts "$@"
368         : '}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}}
369 '
370 }
371
372 t-diff-nogit () {
373         diff --exclude=.git --exclude=.pc -ruN $*
374 }
375
376 t-files-notexist () {
377         local f
378         for f in "$@"; do
379                 if [ -e $f ]; then
380                         fail "$f exists!"
381                 fi
382         done
383 }
384
385 t-cloned-fetched-good () {
386         t-diff-nogit ../extract/$p-${v%-*} .
387         t-clean-on-branch dgit/sid
388         t-refs-same-start
389         t-refs-same \
390                 refs/heads/dgit/sid \
391                 refs/remotes/dgit/dgit/sid
392         t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
393 }
394
395 t-output () {
396         printf "%s${1:+\n}" "$1" >$tmp/t.want
397         shift
398         "$@" >$tmp/t.got
399         diff $tmp/t.want $tmp/t.got
400 }
401
402 t-clean-on-branch () {
403         t-output "## $1" git status -b --porcelain
404 }
405
406 t-setup-done () {
407         local savevars=$1
408         local savedirs=$2
409         local importeval=$3
410
411         local import=IMPORT.${0##*/}
412         exec 4>$tmp/$import.new
413
414         local vn
415         for vn in $savevars; do
416                 perl >&4 -I. -MDebian::Dgit -e '
417                         printf "%s=%s\n", $ARGV[0], shellquote $ARGV[1]
418                 ' $vn "$(eval "printf '%s\n' \"\$$vn\"")"
419         done
420
421         (set -e; cd $tmp; tar cf $import.tar $savedirs)
422
423         printf >&4 "\n%s\n" "$importeval"
424
425         mv -f $tmp/$import.new $tmp/$import
426 }
427
428 t-setup-import () {
429         local setupname=$1
430
431         local setupsrc
432         local lock
433         if [ "x$tmpbase" = x ]; then
434                 # ADTTMP was set on entry to tests/lib, so we
435                 # are not sharing tmp area between tests
436                 setupsrc="$tmp"
437                 lock="$tmp/.dummy.lock"
438         else
439                 setupsrc="$tmpbase/$setupname"
440                 lock="$setupsrc.lock"
441         fi
442
443         local simport="$setupsrc/IMPORT.$setupname"
444
445         if ! [ -e "$simport" ]; then
446                 with-lock-ex -w "$lock" \
447                 xargs -0 -a $tmp/.save-env \
448                 bash -xec '
449                         cd "$1"; shift
450                         setupname="$1"; shift
451                         simport="$1"; shift
452                         if [ -e "$simport" ]; then exit 0; fi
453                         env - "$@" \
454                         "tests/setup/$setupname"
455                 ' x "$root" "$setupname" "$simport"
456         fi
457
458         if [ "x$setupsrc" != "x$tmp" ]; then
459                 (set -e; cd $tmp; tar xf "$simport.tar")
460         fi
461
462         . "$simport"
463 }
464
465 t-git-get-ref-exact () {
466         local ref=$1
467         # does not dereference, unlike t-git-get-ref
468         case "$ref" in
469         refs/*) ;;
470         *) fail "t-git-get-ref-exact bad $ref" ;;
471         esac
472         git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
473 }
474
475 t-git-get-ref () {
476         local ref=$1
477         case "$ref" in
478         refs/*) ;;
479         *) fail "t-git-get-ref bad $ref" ;;
480         esac
481         (git show-ref -d $1 || test $? = 1) | perl -ne '
482                 $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
483                 END { print "$x\n" if length $x; }
484         '
485 }
486
487 t-ref-same-exact () {
488         local name="$1"
489         local val=`t-git-get-ref-exact $name`
490         t-ref-same-val "$name" $val
491 }
492
493 t-ref-same () {
494         local name="$1"
495         local val=`t-git-get-ref $name`
496         t-ref-same-val "$name" $val
497 }
498
499 t-ref-head () {
500         local val=`git rev-parse HEAD`
501         t-ref-same-val HEAD $val
502 }
503
504 t-ref-same-val () {
505         local name="$1"
506         local val=$2
507         case "${t_ref_val-unset}" in
508         unset)          ;;
509         "$val")         ;;
510         *)              fail "ref varies: ($name)\
511  ${val:-nothing} != ${t_ref_val:-nothing} (${t_ref_names[*]})" ;;
512         esac
513         t_ref_val="$val"
514         t_ref_names+=("$name")
515 }
516
517 t-refs-same-start () {
518         unset t_ref_val
519         t_ref_names=()
520 }
521
522 t-refs-same () {
523         local g
524         for g in $*; do
525                 t-ref-same $g
526         done
527 }
528
529 t-refs-notexist () {
530         local val
531         for g in $*; do
532                 val=`t-git-get-ref $g`
533                 if [ "x$val" != x ]; then
534                         fail "ref $g unexpectedly exists ($val)"
535                 fi
536         done
537 }
538
539 t-v-tag () {
540         echo refs/tags/$tagpfx/${v//\~/_}
541 }
542
543 t-format-ref () {
544         git log -n1 --pretty=format:"$1" "$2"
545 }
546
547 t-sametree-parent () {
548         local ref=$1
549         local parent
550         local ctree=$(t-format-ref '%T' "$ref")
551         while :; do
552                 local psame=''
553                 for parent in $(t-format-ref '%P' "$ref"); do
554                         local ptree=$(t-format-ref '%T' "$parent")
555                         if [ "x$ptree" = "x$ctree" ]; then
556                                 psame+=" $parent"
557                         fi
558                 done
559                 case "$psame" in ""|" * *") break ;; esac
560                 ref="${psame# }"
561         done
562         echo "$ref"
563 }
564
565 t-check-pushed-master () {
566         local master=`t-git-get-ref refs/heads/master`
567         if [ x$master = x$t_ref_val ]; then return; fi
568         if [ x$master = x ]; then fail "failed to push master"; fi
569         # didn't update master, it must be not FF
570         local mbase=`t-git-merge-base $master $t_ref_val`
571         if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
572 }
573
574 t-pushed-good () {
575         local branch=$1
576         local suite=${2:-sid}
577         t-refs-same \
578                 refs/heads/$branch
579         t-pushed-good-core
580 }
581         
582 t-pushed-good-core () {
583         t-ref-dsc-dgit
584         t-refs-same \
585                 `t-v-tag` \
586                 refs/remotes/dgit/dgit/$suite
587         t-refs-notexist \
588                 refs/heads/dgit/unstable \
589                 refs/remotes/dgit/dgit/unstable
590         (set -e; cd $dgitrepo
591          t-refs-same \
592                 refs/dgit/$suite \
593                 `t-v-tag`
594          ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
595          t-refs-notexist \
596                 refs/dgit/unstable
597         )
598         git verify-tag `t-v-tag`
599 }
600
601 t-splitbrain-pushed-good--unpack () {
602         cd $tmp
603         rm -rf t-unpack
604         mkdir t-unpack
605         cd t-unpack
606         ln -s $tmp/mirror/pool/main/*.orig*.tar* .
607         ln -s $tmp/incoming/*.orig*.tar* . ||:
608         ln -s $incoming_dsc .
609         ln -s ${incoming_dsc/.dsc/.debian.tar}* .
610         dpkg-source "$@" -x *.dsc
611         cd */.
612         git init
613         git fetch ../../$p "refs/tags/*:refs/tags/*"
614 }
615
616 t-splitbrain-pushed-good--checkprep () {
617         git add -Af .
618         git rm --cached -r --ignore-unmatch .pc
619 }
620
621 t-splitbrain-pushed-good--checkdiff () {
622         local tag=$1
623         t-splitbrain-pushed-good--checkprep
624         t-output "" git diff --stat --cached $tag
625 }
626
627 t-splitbrain-pushed-good-start () {
628         dep14tag=refs/tags/test-dummy/${v//\~/_}
629         dgittag=$(t-v-tag)
630         t-output "" git status --porcelain
631         t-ref-head
632         t-refs-same $dep14tag
633         (set -e; cd $dgitrepo; t-refs-same $dep14tag)
634         git merge-base --is-ancestor $dep14tag $dgittag
635
636         t-refs-same-start
637         t-ref-same refs/heads/split.p
638         case "$(t-git-get-ref refs/heads/split.b)" in
639         "$t_ref_val") ;;
640         "$(git rev-parse refs/heads/split.p^0)") ;;
641         "$(git rev-parse refs/heads/split.p^1)") ;;
642         *) fail 'bad b/p' ;;
643         esac
644         t-pushed-good-core
645
646         t-incoming-dsc
647
648         t-splitbrain-pushed-good--unpack
649         t-splitbrain-pushed-good--checkdiff $dgittag
650 }
651 t-splitbrain-pushed-good-end-made-dep14 () {
652         t-splitbrain-pushed-good--checkdiff $dep14tag
653         cd $tmp/$p
654 }
655
656 t-splitbrain-rm-gitignore-patch () {
657         perl -i -pe '
658                 next unless $_ eq "auto-gitignore\n";
659                 die if $counter++;
660                 chomp;
661                 rename "debian/patches/$_", "../t-auto-gitignore" or die $!;
662                 $_ = "";
663         ' debian/patches/series
664 }
665
666 t-gbp-pushed-good () {
667         local suite=${1:-sid}
668         t-splitbrain-pushed-good-start
669
670         # Right, now we want to check that the maintainer tree and
671         # the dgit tree differ in exactly the ways we expect.  We
672         # achieve this by trying to reconstruct the maintainer tree
673         # from the dgit tree.
674
675         # So, unpack it withut the patches applied
676         t-splitbrain-pushed-good--unpack --skip-patches
677
678         # dgit might have added a .gitignore patch, which we need to
679         # drop and remove
680         t-splitbrain-rm-gitignore-patch
681
682         # Now the result should differ only in non-debian/ .gitignores
683         t-splitbrain-pushed-good--checkprep
684         git diff --cached --name-only $dep14tag >../changed
685         perl -ne '
686                 next if !m#^debian/# && m#(^|/)\.gitignore#;
687                 die "$_ mismatch";
688         ' <../changed
689
690         # If we actually apply the gitignore patch by hand, it
691         # should be perfect:
692         if [ -f ../t-auto-gitignore ]; then
693                 patch --backup-if-mismatch -p1 -u <../t-auto-gitignore
694         fi
695
696         t-splitbrain-pushed-good-end-made-dep14
697 }
698
699 t-unapplied-pushed-good () {
700         t-splitbrain-pushed-good-start
701         t-splitbrain-pushed-good--unpack --skip-patches
702         t-splitbrain-pushed-good-end-made-dep14
703 }
704
705 t-dpm-pushed-good () {
706         t-splitbrain-pushed-good-start
707         t-splitbrain-pushed-good--unpack
708         t-splitbrain-rm-gitignore-patch
709         t-splitbrain-pushed-good-end-made-dep14
710 }
711
712 t-commit-build-push-expect-log () {
713         local msg=$1
714         local mpat=$2
715         t-commit "$msg"
716         t-dgit build
717         LC_MESSAGES=C \
718         t-dgit push --new 2>&1 |tee $tmp/push.log
719         t-grep-mpat "$mpat" $tmp/push.log
720 }
721
722 t-822-field () {
723         local file=$1
724         local field=$2
725         perl -e '
726                 use Dpkg::Control::Hash;
727                 my $h = new Dpkg::Control::Hash allow_pgp=>1;
728                 $h->parse(\*STDIN,"'"$file"'");
729                 my $val = $h->{"'$field'"},"\n";
730                 die "'"$file $field"'" unless defined $val;
731                 print $val,"\n";
732         ' <$file
733 }
734
735 t-stunt-envvar () {
736         local var=$1
737         local tstunt=$2
738         eval '
739                 case "$'$var'" in
740                 "$tstunt:"*)    ;;
741                 *":$tstunt:"*)  ;;
742                 "")             '$var'="$tstunt" ;;
743                 *)              '$var'="$tstunt:$'$var'" ;;
744                 esac
745                 export '$var'
746         '
747 }
748
749 t-tstunt () {
750         local tstunt=$tmp/tstunt
751         t-stunt-envvar PATH $tstunt
752         t-stunt-envvar PERLLIB $tstunt
753         local f
754         for f in "$@"; do
755                 f="./$f"
756                 local d="$tstunt/${f%/*}"
757                 mkdir -p $d
758                 ln -sf "$troot/tstunt/$f" "$d"/.
759         done
760 }
761
762 t-tstunt-parsechangelog () {
763         t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
764 }
765
766 t-tstunt-lintian () {
767         t-tstunt lintian
768 }
769
770 t-tstunt-debuild () {
771         : ${DGIT_TEST_REAL_DEBUILD:=$(type -p debuild)}
772         export DGIT_TEST_REAL_DEBUILD
773         t-tstunt debuild
774 }
775
776 t-incoming-dsc () {
777         local dsc=${p}_${v}.dsc
778         incoming_dsc=$tmp/incoming/$dsc
779 }
780
781 t-ref-dsc-dgit () {
782         t-incoming-dsc
783         local val=`t-822-field $incoming_dsc Dgit`
784         perl -e '$_=shift @ARGV; die "Dgit $_ ?" unless m/^\w+\b/;' "$val"
785         t-ref-same-val $incoming_dsc "$val"
786 }
787
788 t-apply-diff () {
789         local v1=$1
790         local v2=$2
791         (cd $troot/pkg-srcs;
792          debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
793          | patch -p1 -u
794 }
795
796 t-gbp-unapplied-pq2qc () {
797         # does `gbp pq export'
798         # commits the resulting debian/patches on  qc/BRANCH
799         # leaves us on qc/BRANCH (eg "qc/quilt-tip"))
800         # qc/BRANCH is not fast-forwarding
801
802         gbp pq export
803
804         branch=`git symbolic-ref HEAD`
805         branch=${branch#refs/heads/}
806
807         case "$branch" in
808         */*) fail "unexpected branch $branch" ;;
809         esac
810
811         git branch -f qc/$branch
812         git checkout qc/$branch
813         git add debian/patches
814         git commit -m 'Commit patch queue'
815 }
816
817 t-git-pseudo-merge () {
818         # like   git merge -s ours
819         if [ ! "$git_pseuomerge_opts" ]; then
820                 if git merge --help \
821                  | grep -q allow-unrelated-histories; then
822                         git_pseuomerge_opts='--allow-unrelated-histories'
823                 fi
824                 git_pseuomerge_opts+=' -s ours'
825         fi
826         git merge $git_pseuomerge_opts "$@"
827 }
828
829 t-gbp-example-prep-no-ff () {
830         t-tstunt-parsechangelog
831         t-archive example 1.0-1
832         t-git-none
833         t-worktree 1.0
834
835         cd example
836
837         t-dgit fetch
838
839         git checkout -b patch-queue/quilt-tip-2 patch-queue/quilt-tip
840         gbp pq rebase
841
842         echo '/* some comment */' >>src.c
843         git add src.c
844         git commit -m 'Add a comment to an upstream file'
845
846         t-gbp-unapplied-pq2qc
847
848         t-commit 'some updates' 1.0-2
849 }
850
851 t-gbp-example-prep () {
852         t-gbp-example-prep-no-ff
853
854         t-git-pseudo-merge \
855                 -m 'Pseudo-merge to make descendant of archive' \
856                 remotes/dgit/dgit/sid
857 }
858
859 t-commit () {
860         local msg=$1
861         v=${2:-${majorv:-1}.$revision}
862         dch --force-distribution -v$v --distribution ${3:-unstable} "$1"
863         git add debian/changelog
864         debcommit
865         revision=$(( ${revision-0} + 1 ))
866 }
867
868 t-git-config () {
869         git config --global "$@"
870 }
871
872 t-drs () {
873         export DGIT_TEST_TROOT=$troot
874  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
875  t-git-config dgit-distro.test-dummy.git-check true
876  t-git-config dgit-distro.test-dummy.git-create true
877  t-git-config dgit-distro.test-dummy.dgit-tag-format new,old,maint
878         cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
879         cp $troot/suites $tmp/.
880         cp $troot/suites $tmp/suites-master
881
882         export t_check_pushed_master=t-check-pushed-master
883
884         drs_dispatch=$tmp/distro=test-dummy
885         mkdir $drs_dispatch
886
887         if [ "x$DGIT_TEST_INTREE" != x ]; then
888                 ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
889         fi
890
891         ln -sf $tmp/git $drs_dispatch/repos
892         ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
893         mkdir -p $drs_dispatch/keyrings
894         ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
895         ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
896         ln -sf /bin/true $drs_dispatch/policy-hook
897 }
898
899 t-newtag () {
900  export tagpfx=archive/test-dummy
901  t-git-config dgit-distro.test-dummy.dgit-tag-format new,maint
902 }
903 t-oldtag () {
904  export tagpfx=test-dummy
905  t-git-config dgit-distro.test-dummy.dgit-tag-format old
906 }
907
908 t-dsd () {
909         t-drs
910  t-git-config dgit-distro.test-dummy.ssh "$troot/dsd-ssh"
911  t-git-config dgit-distro.test-dummy.git-check ssh-cmd
912  t-git-config dgit-distro.test-dummy.git-create true
913  t-git-config dgit-distro.test-dummy.git-url \
914                 "ext::$troot/dsd-ssh X %S /dgit/test-dummy/repos"
915
916  t-git-config dgit-distro.test-dummy.diverts.drs /drs
917  t-git-config dgit-distro.test-dummy/drs.ssh "$troot/ssh"
918  t-git-config dgit-distro.test-dummy/drs.git-url $tmp/git
919  t-git-config dgit-distro.test-dummy/drs.git-check ssh-cmd
920  t-git-config dgit-distro.test-dummy/drs.git-create ssh-cmd
921
922         echo 'no-such-package* drs' >$drs_dispatch/diverts
923 }
924
925 t-policy-admin () {
926         ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
927 }
928
929 t-policy-nonexist () {
930         ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
931 }
932
933 t-make-hook-link () {
934         local hook=$1 # in infra/
935         local linkpath=$2
936         hook=${DGIT_INFRA_PFX}$hook
937         case $hook in
938         */*)    ;;
939         *)      hook=`type -P $hook` ;;
940         esac
941         ln -sf "$hook" $linkpath
942 }
943
944 t-policy () {
945         local policyhook=$1
946         t-make-hook-link $policyhook $drs_dispatch/policy-hook
947 }
948
949 t-debpolicy () {
950         t-dsd
951         t-policy dgit-repos-policy-debian
952
953         mkdir $tmp/git
954         t-policy-admin create-db
955 }
956
957 t-policy-periodic () {
958         ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
959                 test-dummy $drs_dispatch '' --cron
960 }
961
962 t-restrict () {
963         local restriction=$1
964         (cd $root; t-restriction-$restriction >&2)
965 }
966
967 t-dependencies () {
968         : "Hopefully installed: $*"
969 }
970
971 t-chain-test () {
972         local ct=$1
973         local d=${0%/*}
974         cd $root
975         export DGIT_TEST_TESTNAME="$testname"
976         export DGIT_TEST_TMPBASE="$tmpbase"
977         export ADTTMP=$tmp
978         exec "$d/$ct"
979 }       
980
981 t-alt-test () {
982         local t=${0##*/}
983         t-${t%%-*}
984         t-chain-test "${t#*-}"
985 }
986
987 case "$0" in
988 */gnupg) ;;
989 *)      t-setup-import gnupg    ;;
990 esac